﻿Public Class Form1

    Private Sub btnStructs_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnStructs.Click
        Dim dateTime As DateTime = New DateTime(2011, 2, 20)

        MessageBox.Show("Before method call: " & dateTime)  ' This will be 2/20/2011
        AddTwoMonthsMethod(dateTime)
        MessageBox.Show("After method call: " & dateTime) ' This will still be 2/20/2011
    End Sub

    Private Sub AddTwoMonthsMethod(ByVal dateTime As DateTime)
        dateTime = dateTime.AddMonths(2)
        MessageBox.Show("Inside method: " & dateTime.ToString())    ' This will be 4/20/2011
    End Sub

    Private Sub btnDateProperty_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDateProperty.Click
        Dim dateTime As DateTime = New DateTime(2011, 2, 20, 3, 45, 33)
        MessageBox.Show("Date and Time " & dateTime)  ' Will be 2/20/2011 3:45:33 am
        MessageBox.Show("Date Only " & dateTime.Date)  ' Will be just 2/20/2011
        MessageBox.Show("TimeOfDay " & dateTime.TimeOfDay.ToString())  ' Will be 03:45:33 am
        MessageBox.Show("Hour " & dateTime.Hour)  ' Will be 3
        MessageBox.Show("Day of Week " & dateTime.DayOfWeek)  ' Will be 0 - for Sunday
        MessageBox.Show("Day of Year " & dateTime.DayOfYear)  ' Will be 51
    End Sub

    Private Sub btnFunctions_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnFunctions.Click
        Dim dateTime As DateTime = New DateTime(2011, 2, 20, 3, 45, 33)

        dateTime = dateTime.AddYears(5)
        MessageBox.Show(dateTime)  ' Will be 2/20/2016 3:45:33 am

        dateTime = dateTime.AddMinutes(-15)
        MessageBox.Show(dateTime)  ' Will be 2/20/2016 3:30:33 am
    End Sub

    Private Sub btnEquatable_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnEquatable.Click
        Dim date1 As DateTime = New DateTime(2011, 2, 20)
        Dim date2 As DateTime = New DateTime(2011, 2, 20)
        Dim dateTime As DateTime = New DateTime(2011, 2, 20, 3, 45, 33)

        MessageBox.Show(date1.Equals(date2).ToString())  ' Will be true
        MessageBox.Show(date1.Equals(dateTime).ToString())  ' Will be false

        MessageBox.Show((date1 = date2).ToString())  ' Will be true
        MessageBox.Show((date1 <> dateTime).ToString())  ' Will be true
    End Sub

    Private Sub btnComparable_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnComparable.Click
        Dim date1 As DateTime = New DateTime(2011, 2, 20)
        Dim date2 As DateTime = New DateTime(2011, 2, 25)
        Dim date3 As DateTime = New DateTime(2011, 2, 20)

        MessageBox.Show(date1.CompareTo(date2).ToString())  ' Will be -1
        MessageBox.Show(date2.CompareTo(date1).ToString())  ' Will be 1
        MessageBox.Show(date1.CompareTo(date3).ToString())  ' Will be 0
        
        MessageBox.Show((date1 < date2).ToString())  ' Will be true
        MessageBox.Show((date1 > date2).ToString())  ' Will be false
        MessageBox.Show((date1 >= date3).ToString())  ' Will be true
    End Sub

    Private Sub btnStaticFunctions_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnStaticFunctions.Click
        MessageBox.Show(DateTime.DaysInMonth(2011, 2))  ' Will be 28
        MessageBox.Show(DateTime.DaysInMonth(2012, 2))  ' Will be 29 - leap year

        MessageBox.Show(DateTime.IsLeapYear(2011))  ' Will be false
        MessageBox.Show(DateTime.IsLeapYear(2012))  ' Will be true

        MessageBox.Show(DateTime.Now)  ' Will be current Date & Time
        MessageBox.Show(DateTime.Today)  ' Will be just current Date
    End Sub

    Private Sub btnParse_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnParse.Click
        Dim value As DateTime
        value = DateTime.Parse("01/29/1990")
        MessageBox.Show(value)  ' Will be 1/29/1990

        value = DateTime.Parse("blah")  ' Exception is thrown here
        MessageBox.Show(value)  ' Won't get here 
    End Sub

    Private Sub btnTryParse_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnTryParse.Click
        Dim value As DateTime
        Dim result As Boolean

        result = DateTime.TryParse("01/29/1990", value)
        MessageBox.Show(result & ", " & value)  ' Will be True, 1/29/1990

        result = DateTime.TryParse("blah", value)
        MessageBox.Show(result & ", " & value)  ' Will be False, DateTime.MinValue
    End Sub

    Private Sub btnToStrings_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnToStrings.Click
        Dim dateTime As DateTime = New DateTime(2011, 2, 20, 3, 45, 33)

        MessageBox.Show(dateTime.ToShortDateString())   ' 2/20/2011
        MessageBox.Show(dateTime.ToLongDateString())   ' Sunday, February 20, 2011
    End Sub
End Class
